Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 74430)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -2638,149 +1576,669 @@
             goto exit;
         }
         
-        context->firstoff = (startoff % ci->stripe_length) / Vcb->superblock.sector_size;
-        context->startoffstripe = startoffstripe;
-        context->sectors_per_stripe = ci->stripe_length / Vcb->superblock.sector_size;
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+            
+            if (!context.va) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+        } else
+            context.va = buf;
         
+        context.firstoff = (startoff % ci->stripe_length) / Vcb->superblock.sector_size;
+        context.startoffstripe = startoffstripe;
+        context.sectors_per_stripe = ci->stripe_length / Vcb->superblock.sector_size;
+        
         startoffstripe *= ci->sub_stripes;
         endoffstripe *= ci->sub_stripes;
         
+        if (c)
+            c->last_stripe = (orig_ls + 1) % ci->sub_stripes;
+        
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+        
+        stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_data_stripe*) * ci->num_stripes / ci->sub_stripes, ALLOC_TAG);
+        if (!stripes) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        RtlZeroMemory(stripes, sizeof(read_data_stripe*) * ci->num_stripes / ci->sub_stripes);
+        
         for (i = 0; i < ci->num_stripes; i += ci->sub_stripes) {
-            if (startoffstripe > i) {
-                stripestart[i] = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                stripestart[i] = startoff;
-            } else {
-                stripestart[i] = startoff - (startoff % ci->stripe_length);
+            UINT64 sstart, send;
+            
+            if (startoffstripe > i)
+                sstart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+            else if (startoffstripe == i)
+                sstart = startoff;
+            else
+                sstart = startoff - (startoff % ci->stripe_length);
+            
+            if (endoffstripe > i)
+                send = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+            else if (endoffstripe == i)
+                send = endoff + 1;
+            else
+                send = endoff - (endoff % ci->stripe_length);
+            
+            for (j = 0; j < ci->sub_stripes; j++) {
+                if (j == orig_ls) {
+                    context.stripes[i+j].stripestart = sstart;
+                    context.stripes[i+j].stripeend = send;
+                    stripes[i / ci->sub_stripes] = &context.stripes[i+j];
+                    
+                    if (sstart != send) {
+                        context.stripes[i+j].mdl = IoAllocateMdl(context.va, send - sstart, FALSE, FALSE, NULL);
+
+                        if (!context.stripes[i+j].mdl) {
+                            ERR("IoAllocateMdl failed\n");
+                            Status = STATUS_INSUFFICIENT_RESOURCES;
+                            goto exit;
+                        }
+                    }
+                } else
+                    context.stripes[i+j].status = ReadDataStatus_Skip;
             }
+        }
+        
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes / ci->sub_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes / ci->sub_stripes);
+
+        pos = 0;
+        stripe = startoffstripe / ci->sub_stripes;
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns = (PFN_NUMBER*)(stripes[stripe]->mdl + 1);
             
-            if (endoffstripe > i) {
-                stripeend[i] = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stripeend[i] = endoff + 1;
+            if (pos == 0) {
+                UINT32 readlen = min(stripes[stripe]->stripeend - stripes[stripe]->stripestart, ci->stripe_length - (stripes[stripe]->stripestart % ci->stripe_length));
+
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                stripeoff[stripe] += readlen;
+                pos += readlen;
+            } else if (length - pos < ci->stripe_length) {
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (length - pos) * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                pos = length;
             } else {
-                stripeend[i] = endoff - (endoff % ci->stripe_length);
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                stripeoff[stripe] += ci->stripe_length;
+                pos += ci->stripe_length;
             }
             
-            for (j = 1; j < ci->sub_stripes; j++) {
-                stripestart[i+j] = stripestart[i];
-                stripeend[i+j] = stripeend[i];
+            stripe = (stripe + 1) % (ci->num_stripes / ci->sub_stripes);
+        }
+
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
+        ExFreePool(stripes);
+    } else if (type == BLOCK_FLAG_DUPLICATE) {
+        UINT64 orig_ls;
+        
+        if (c)
+            orig_ls = i = c->last_stripe;
+        else
+            orig_ls = i = 0;
+        
+        while (!devices[i]) {
+            i = (i + 1) % ci->num_stripes;
+            
+            if (i == orig_ls) {
+                ERR("no devices available to service request\n");
+                Status = STATUS_DEVICE_NOT_READY;
+                goto exit;
             }
         }
         
-        context->stripes_cancel = 1;
-    } else if (type == BLOCK_FLAG_DUPLICATE) {
-        for (i = 0; i < ci->num_stripes; i++) {
-            stripestart[i] = addr - offset;
-            stripeend[i] = stripestart[i] + length;
+        if (c)
+            c->last_stripe = (i + 1) % ci->num_stripes;
+
+        context.stripes[i].stripestart = addr - offset;
+        context.stripes[i].stripeend = context.stripes[i].stripestart + length;
+
+        context.stripes[i].buf = buf;
+        context.stripes[i].not_alloc = TRUE;
+        
+        if (file_read) {
+            UINT8* va;
+    
+            va = (UINT8*)MmGetMdlVirtualAddress(Irp->MdlAddress) + irp_offset;
+            
+            context.stripes[i].mdl = IoAllocateMdl(va, context.stripes[i].stripeend - context.stripes[i].stripestart, FALSE, FALSE, NULL);
+            if (!context.stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+            
+            IoBuildPartialMdl(Irp->MdlAddress, context.stripes[i].mdl, va, context.stripes[i].stripeend - context.stripes[i].stripestart);
+        } else {
+            context.stripes[i].mdl = IoAllocateMdl(context.stripes[i].buf, context.stripes[i].stripeend - context.stripes[i].stripestart, FALSE, FALSE, NULL);
+
+            if (!context.stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+            
+            MmProbeAndLockPages(context.stripes[i].mdl, KernelMode, IoWriteAccess);
         }
-        
-        context->stripes_cancel = ci->num_stripes - 1;
     } else if (type == BLOCK_FLAG_RAID5) {
         UINT64 startoff, endoff;
-        UINT16 endoffstripe;
-        UINT64 start = 0xffffffffffffffff, end = 0;
+        UINT16 endoffstripe, parity;
+        UINT32 *stripeoff, pos;
+        PMDL master_mdl;
+        PFN_NUMBER *pfns, dummy;
+        BOOL need_dummy = FALSE;
         
         get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes - 1, &startoff, &startoffstripe);
         get_raid0_offset(addr + length - offset - 1, ci->stripe_length, ci->num_stripes - 1, &endoff, &endoffstripe);
         
-        for (i = 0; i < ci->num_stripes - 1; i++) {
-            UINT64 ststart, stend;
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
             
-            if (startoffstripe > i) {
-                ststart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                ststart = startoff;
-            } else {
-                ststart = startoff - (startoff % ci->stripe_length);
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
             }
-              
-            if (endoffstripe > i) {
-                stend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stend = endoff + 1;
-            } else {
-                stend = endoff - (endoff % ci->stripe_length);
-            }
+        } else
+            context.va = buf;
+
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+        
+        MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+        
+        pos = 0;
+        while (pos < length) {
+            parity = (((addr - offset + pos) / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
             
-            if (ststart != stend) {
-                if (ststart < start) {
-                    start = ststart;
-                    firststripesize = ci->stripe_length - (ststart % ci->stripe_length);
+            if (pos == 0) {
+                UINT16 stripe = (parity + startoffstripe + 1) % ci->num_stripes;
+                ULONG skip, readlen;
+                
+                i = startoffstripe;
+                while (stripe != parity) {
+                    if (i == startoffstripe) {
+                        readlen = min(length, ci->stripe_length - (startoff % ci->stripe_length));
+                        
+                        context.stripes[stripe].stripestart = startoff;
+                        context.stripes[stripe].stripeend = startoff + readlen;
+                        
+                        pos += readlen;
+                        
+                        if (pos == length)
+                            break;
+                    } else {
+                        readlen = min(length - pos, ci->stripe_length);
+                        
+                        context.stripes[stripe].stripestart = startoff - (startoff % ci->stripe_length);
+                        context.stripes[stripe].stripeend = context.stripes[stripe].stripestart + readlen;
+                        
+                        pos += readlen;
+                        
+                        if (pos == length)
+                            break;
+                    }
+                    
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
                 }
                 
-                if (stend > end)
-                    end = stend;
+                if (pos == length)
+                    break;
+                
+                for (i = 0; i < startoffstripe; i++) {
+                    UINT16 stripe = (parity + i + 1) % ci->num_stripes;
+                    
+                    context.stripes[stripe].stripestart = context.stripes[stripe].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                }
+                
+                context.stripes[parity].stripestart = context.stripes[parity].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                
+                if (length - pos > ci->num_stripes * (ci->num_stripes - 1) * ci->stripe_length) {
+                    skip = ((length - pos) / (ci->num_stripes * (ci->num_stripes - 1) * ci->stripe_length)) - 1;
+                    
+                    for (i = 0; i < ci->num_stripes; i++) {
+                        context.stripes[i].stripeend += skip * ci->num_stripes * ci->stripe_length;
+                    }
+                    
+                    pos += skip * (ci->num_stripes - 1) * ci->num_stripes * ci->stripe_length;
+                    need_dummy = TRUE;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 1)) {
+                for (i = 0; i < ci->num_stripes; i++) {
+                    context.stripes[i].stripeend += ci->stripe_length;
+                }
+                
+                pos += ci->stripe_length * (ci->num_stripes - 1);
+                need_dummy = TRUE;
+            } else {
+                UINT16 stripe = (parity + 1) % ci->num_stripes;
+                
+                i = 0;
+                while (stripe != parity) {
+                    if (endoffstripe == i) {
+                        context.stripes[stripe].stripeend = endoff + 1;
+                        break;
+                    } else if (endoffstripe > i)
+                        context.stripes[stripe].stripeend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+                    
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+                
+                break;
             }
         }
         
         for (i = 0; i < ci->num_stripes; i++) {
-            stripestart[i] = start;
-            stripeend[i] = end;
+            if (context.stripes[i].stripestart != context.stripes[i].stripeend) {
+                context.stripes[i].mdl = IoAllocateMdl(context.va, context.stripes[i].stripeend - context.stripes[i].stripestart, FALSE, FALSE, NULL);
+
+                if (!context.stripes[i].mdl) {
+                    ERR("IoAllocateMdl failed\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto exit;
+                }
+            }
         }
         
-        context->stripes_cancel = Vcb->options.raid5_recalculation;
+        if (need_dummy) {
+            dummypage = ExAllocatePoolWithTag(NonPagedPool, PAGE_SIZE, ALLOC_TAG);
+            if (!dummypage) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+            
+            dummy_mdl = IoAllocateMdl(dummypage, PAGE_SIZE, FALSE, FALSE, NULL);
+            if (!dummy_mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                ExFreePool(dummypage);
+                goto exit;
+            }
+            
+            MmBuildMdlForNonPagedPool(dummy_mdl);
+            
+            dummy = *(PFN_NUMBER*)(dummy_mdl + 1);
+        }
+        
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes);
+
+        pos = 0;
+        
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns;
+            
+            parity = (((addr - offset + pos) / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
+            
+            if (pos == 0) {
+                UINT16 stripe = (parity + startoffstripe + 1) % ci->num_stripes;
+                UINT32 readlen = min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart,
+                                                       ci->stripe_length - (context.stripes[stripe].stripestart % ci->stripe_length)));
+                
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                stripeoff[stripe] = readlen;
+                pos += readlen;
+                
+                stripe = (stripe + 1) % ci->num_stripes;
+                
+                while (stripe != parity) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+                    
+                    if (readlen == 0)
+                        break;
+                    
+                    RtlCopyMemory(stripe_pfns, &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                    
+                    stripeoff[stripe] = readlen;
+                    pos += readlen;
+                    
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 1)) {
+                UINT16 stripe = (parity + 1) % ci->num_stripes;
+                
+                while (stripe != parity) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                    
+                    stripeoff[stripe] += ci->stripe_length;
+                    pos += ci->stripe_length;
+                    
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+                
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[parity].mdl + 1);
+                
+                for (i = 0; i < ci->stripe_length >> PAGE_SHIFT; i++) {
+                    stripe_pfns[stripeoff[parity] >> PAGE_SHIFT] = dummy;
+                    stripeoff[parity] += PAGE_SIZE;
+                }
+            } else {
+                UINT16 stripe = (parity + 1) % ci->num_stripes;
+                UINT32 readlen;
+                
+                while (pos < length) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+                    
+                    if (readlen == 0)
+                        break;
+                    
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                    
+                    stripeoff[stripe] += readlen;
+                    pos += readlen;
+                    
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            }
+        }
+        
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
     } else if (type == BLOCK_FLAG_RAID6) {
         UINT64 startoff, endoff;
-        UINT16 endoffstripe;
-        UINT64 start = 0xffffffffffffffff, end = 0;
+        UINT16 endoffstripe, parity1;
+        UINT32 *stripeoff, pos;
+        PMDL master_mdl;
+        PFN_NUMBER *pfns, dummy;
+        BOOL need_dummy = FALSE;
         
         get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes - 2, &startoff, &startoffstripe);
         get_raid0_offset(addr + length - offset - 1, ci->stripe_length, ci->num_stripes - 2, &endoff, &endoffstripe);
         
-        for (i = 0; i < ci->num_stripes - 2; i++) {
-            UINT64 ststart, stend;
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
             
-            if (startoffstripe > i) {
-                ststart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                ststart = startoff;
-            } else {
-                ststart = startoff - (startoff % ci->stripe_length);
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
             }
-              
-            if (endoffstripe > i) {
-                stend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stend = endoff + 1;
-            } else {
-                stend = endoff - (endoff % ci->stripe_length);
-            }
+        } else
+            context.va = buf;
+
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+        
+        MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+        
+        pos = 0;
+        while (pos < length) {
+            parity1 = (((addr - offset + pos) / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
             
-            if (ststart != stend) {
-                if (ststart < start) {
-                    start = ststart;
-                    firststripesize = ci->stripe_length - (ststart % ci->stripe_length);
+            if (pos == 0) {
+                UINT16 stripe = (parity1 + startoffstripe + 2) % ci->num_stripes, parity2;
+                ULONG skip, readlen;
+                
+                i = startoffstripe;
+                while (stripe != parity1) {
+                    if (i == startoffstripe) {
+                        readlen = min(length, ci->stripe_length - (startoff % ci->stripe_length));
+                        
+                        context.stripes[stripe].stripestart = startoff;
+                        context.stripes[stripe].stripeend = startoff + readlen;
+                        
+                        pos += readlen;
+                        
+                        if (pos == length)
+                            break;
+                    } else {
+                        readlen = min(length - pos, ci->stripe_length);
+                        
+                        context.stripes[stripe].stripestart = startoff - (startoff % ci->stripe_length);
+                        context.stripes[stripe].stripeend = context.stripes[stripe].stripestart + readlen;
+                        
+                        pos += readlen;
+                        
+                        if (pos == length)
+                            break;
+                    }
+                    
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
                 }
                 
-                if (stend > end)
-                    end = stend;
+                if (pos == length)
+                    break;
+                
+                for (i = 0; i < startoffstripe; i++) {
+                    UINT16 stripe = (parity1 + i + 2) % ci->num_stripes;
+                    
+                    context.stripes[stripe].stripestart = context.stripes[stripe].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                }
+                
+                context.stripes[parity1].stripestart = context.stripes[parity1].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                
+                parity2 = (parity1 + 1) % ci->num_stripes;
+                context.stripes[parity2].stripestart = context.stripes[parity2].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                
+                if (length - pos > ci->num_stripes * (ci->num_stripes - 2) * ci->stripe_length) {
+                    skip = ((length - pos) / (ci->num_stripes * (ci->num_stripes - 2) * ci->stripe_length)) - 1;
+                    
+                    for (i = 0; i < ci->num_stripes; i++) {
+                        context.stripes[i].stripeend += skip * ci->num_stripes * ci->stripe_length;
+                    }
+                    
+                    pos += skip * (ci->num_stripes - 2) * ci->num_stripes * ci->stripe_length;
+                    need_dummy = TRUE;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 2)) {
+                for (i = 0; i < ci->num_stripes; i++) {
+                    context.stripes[i].stripeend += ci->stripe_length;
+                }
+                
+                pos += ci->stripe_length * (ci->num_stripes - 2);
+                need_dummy = TRUE;
+            } else {
+                UINT16 stripe = (parity1 + 2) % ci->num_stripes;
+                
+                i = 0;
+                while (stripe != parity1) {
+                    if (endoffstripe == i) {
+                        context.stripes[stripe].stripeend = endoff + 1;
+                        break;
+                    } else if (endoffstripe > i)
+                        context.stripes[stripe].stripeend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+                    
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+                
+                break;
             }
         }
         
         for (i = 0; i < ci->num_stripes; i++) {
-            stripestart[i] = start;
-            stripeend[i] = end;
+            if (context.stripes[i].stripestart != context.stripes[i].stripeend) {
+                context.stripes[i].mdl = IoAllocateMdl(context.va, context.stripes[i].stripeend - context.stripes[i].stripestart, FALSE, FALSE, NULL);
+
+                if (!context.stripes[i].mdl) {
+                    ERR("IoAllocateMdl failed\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto exit;
+                }
+            }
         }
         
-        context->stripes_cancel = Vcb->options.raid6_recalculation;
+        if (need_dummy) {
+            dummypage = ExAllocatePoolWithTag(NonPagedPool, PAGE_SIZE, ALLOC_TAG);
+            if (!dummypage) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+            
+            dummy_mdl = IoAllocateMdl(dummypage, PAGE_SIZE, FALSE, FALSE, NULL);
+            if (!dummy_mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                ExFreePool(dummypage);
+                goto exit;
+            }
+            
+            MmBuildMdlForNonPagedPool(dummy_mdl);
+            
+            dummy = *(PFN_NUMBER*)(dummy_mdl + 1);
+        }
+        
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes);
+
+        pos = 0;
+        
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns;
+            
+            parity1 = (((addr - offset + pos) / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
+            
+            if (pos == 0) {
+                UINT16 stripe = (parity1 + startoffstripe + 2) % ci->num_stripes;
+                UINT32 readlen = min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart,
+                                                       ci->stripe_length - (context.stripes[stripe].stripestart % ci->stripe_length)));
+                
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                stripeoff[stripe] = readlen;
+                pos += readlen;
+                
+                stripe = (stripe + 1) % ci->num_stripes;
+                
+                while (stripe != parity1) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+                    
+                    if (readlen == 0)
+                        break;
+                    
+                    RtlCopyMemory(stripe_pfns, &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                    
+                    stripeoff[stripe] = readlen;
+                    pos += readlen;
+                    
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 2)) {
+                UINT16 stripe = (parity1 + 2) % ci->num_stripes;
+                UINT16 parity2 = (parity1 + 1) % ci->num_stripes;
+                
+                while (stripe != parity1) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                    
+                    stripeoff[stripe] += ci->stripe_length;
+                    pos += ci->stripe_length;
+                    
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+                
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[parity1].mdl + 1);
+                
+                for (i = 0; i < ci->stripe_length >> PAGE_SHIFT; i++) {
+                    stripe_pfns[stripeoff[parity1] >> PAGE_SHIFT] = dummy;
+                    stripeoff[parity1] += PAGE_SIZE;
+                }
+                
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[parity2].mdl + 1);
+                
+                for (i = 0; i < ci->stripe_length >> PAGE_SHIFT; i++) {
+                    stripe_pfns[stripeoff[parity2] >> PAGE_SHIFT] = dummy;
+                    stripeoff[parity2] += PAGE_SIZE;
+                }
+            } else {
+                UINT16 stripe = (parity1 + 2) % ci->num_stripes;
+                UINT32 readlen;
+                
+                while (pos < length) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+                    
+                    if (readlen == 0)
+                        break;
+                    
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                    
+                    stripeoff[stripe] += readlen;
+                    pos += readlen;
+                    
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            }
+        }
+        
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
     }
     
-    KeInitializeSpinLock(&context->spin_lock);
+    context.address = addr;
     
-    context->address = addr;
-    
     for (i = 0; i < ci->num_stripes; i++) {
-        if (!devices[i] || stripestart[i] == stripeend[i]) {
-            context->stripes[i].status = ReadDataStatus_MissingDevice;
-            context->stripes[i].buf = NULL;
-            context->stripes_left--;
+        if (!devices[i] || context.stripes[i].stripestart == context.stripes[i].stripeend) {
+            context.stripes[i].status = ReadDataStatus_MissingDevice;
+            context.stripes_left--;
             
             if (!devices[i])
                 missing_devices++;
         }
     }
-      
+
     if (missing_devices > allowed_missing) {
         ERR("not enough devices to service request (%u missing)\n", missing_devices);
         Status = STATUS_UNEXPECTED_IO_ERROR;
